import numpy as np
import pickle
from keras.utils import plot_model

from datasets.dataloading import separate_test_data, separate_training_validation_data_spi, \
    separate_training_validation_data_exp
from models.model_evaluator import test_model_peewee_sub_net
from models.sub_network_model import SubNetworkModel
import datasets.dataset_generation as dsg
from util.model_input_util import create_multiple_target_output, create_features_multiple_input, \
    create_multiple_inputs_targets_sub_net_peewee


class SubExpectedLineup(SubNetworkModel):

    def __init__(self, sub_input_network_dims, factor_input_sizes,
                 super_network_dims, model_number, dir_name="sub-expected-lineup", model_name="sub-expected-lineup",
                 loss="categorical_crossentropy",
                 activation_function="relu", batch_size=256, optimizer='adam', learning_rate=0.0001):
        super().__init__(sub_input_network_dims, factor_input_sizes, super_network_dims,
                         model_number=model_number, dir_name=dir_name, model_name=model_name, loss=loss,
                         activation_function=activation_function,
                         batch_size=batch_size, optimizer=optimizer, learning_rate=learning_rate)
        #plot_model(self.model, to_file="model.png")

    @staticmethod
    def get_default_features():
        feature_dict = {
            "fatigue_factors": ['h_days_since_last_exp', 'a_days_since_last_exp'],
            "strength_factors": ['h_season_team_xG_lineup_list', 'a_season_team_xG_lineup_list', 'h_season_team_xGA', 'a_season_team_xGA'],
            "form_factors": ['h_recent_team_xG_lineup_list', 'a_recent_team_xG_lineup_list', 'h_recent_team_xGA', 'a_recent_team_xGA'],
        }
        feature_list = feature_dict['fatigue_factors'] + feature_dict['form_factors'] + feature_dict['strength_factors']
        feature_dict['feature_list'] = feature_list
        return feature_dict
